var _this = this,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\-CTooltipPopoverWrapper.js";

import React, { useEffect, useRef } from 'react';
import PropTypes from 'prop-types'; //import CPopperContent from './CPopperContent';

import { Manager, Reference, Popper } from 'react-popper';
import { getTarget, targetPropType, omit, PopperPlacements, mapToCssModules, DOMElement } from './Shared/helper.js'; // global

var DEFAULT_DELAYS = {
  show: 0,
  hide: 250
};

var isInDOMSubtree = function isInDOMSubtree(element, subtreeRoot) {
  return subtreeRoot && (element === subtreeRoot || subtreeRoot.contains(element));
}; //component - CoreUI / CTooltipPopoverWrapper


var CTooltipPopoverWrapper = function CTooltipPopoverWrapper(props) {
  var className = props.className,
      cssModule = props.cssModule,
      innerClassName = props.innerClassName,
      target = props.target,
      isOpen = props.show,
      hideArrow = props.hideArrow,
      boundariesElement = props.boundariesElement,
      placement = props.placement,
      placementPrefix = props.placementPrefix,
      arrowClassName = props.arrowClassName,
      container = props.container,
      modifiers = props.modifiers,
      offset = props.offset,
      reference = props.reference,
      children = props.children;
  return /*#__PURE__*/React.createElement(Manager, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 54,
      columnNumber: 5
    }
  }, /*#__PURE__*/React.createElement(Reference, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 55,
      columnNumber: 7
    }
  }, reference), /*#__PURE__*/React.createElement(Popper, {
    placement: placement,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 58,
      columnNumber: 7
    }
  }, children));
};

CTooltipPopoverWrapper.propTypes = process.env.NODE_ENV !== "production" ? {
  className: PropTypes.string,
  cssModule: PropTypes.object,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  placement: PropTypes.oneOf(PopperPlacements),
  target: targetPropType.isRequired,
  container: targetPropType,
  show: PropTypes.bool,
  disabled: PropTypes.bool,
  hideArrow: PropTypes.bool,
  boundariesElement: PropTypes.oneOfType([PropTypes.string, DOMElement]),
  innerClassName: PropTypes.string,
  arrowClassName: PropTypes.string,
  toggle: PropTypes.func,
  autohide: PropTypes.bool,
  placementPrefix: PropTypes.string,
  delay: PropTypes.oneOfType([PropTypes.shape({
    show: PropTypes.number,
    hide: PropTypes.number
  }), PropTypes.number]),
  modifiers: PropTypes.object,
  offset: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  trigger: PropTypes.string
} : {};
CTooltipPopoverWrapper.defaultProps = {
  show: false,
  hideArrow: false,
  autohide: false,
  delay: DEFAULT_DELAYS,
  toggle: function toggle() {},
  trigger: 'click'
};
export default CTooltipPopoverWrapper;