var _this = this,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CCard.js";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { tagPropType, mapToCssModules } from './Shared/helper.js';
import CCardBody from './CCardBody';
import CCardHeader from './CCardHeader';
import CCardFooter from './CCardFooter'; //component - CoreUI / CCard

var CCard = function CCard(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      custom = props.custom,
      innerRef = props.innerRef,
      color = props.color,
      textColor = props.textColor,
      borderColor = props.borderColor,
      accentColor = props.accentColor,
      headerSlot = props.headerSlot,
      footerSlot = props.footerSlot,
      align = props.align,
      bodyClassName = props.bodyClassName,
      bodyProps = props.bodyProps,
      attributes = _objectWithoutPropertiesLoose(props, ["tag", "children", "className", "cssModule", "custom", "innerRef", "color", "textColor", "borderColor", "accentColor", "headerSlot", "footerSlot", "align", "bodyClassName", "bodyProps"]); //render


  var classes = mapToCssModules(classNames(className, 'card', align ? "text-" + align : false, textColor ? "text-" + textColor : false, color ? "bg-" + color : false, borderColor ? "border-" + borderColor : false, accentColor ? "card-accent-" + accentColor : false), cssModule);
  if (!custom) return /*#__PURE__*/React.createElement(Tag, _extends({}, attributes, {
    className: classes,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 47,
      columnNumber: 7
    }
  }), headerSlot ? /*#__PURE__*/React.createElement(CCardHeader, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 49,
      columnNumber: 9
    }
  }, headerSlot) : '', /*#__PURE__*/React.createElement(CCardBody, _extends({}, bodyProps, {
    className: bodyClassName,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 53,
      columnNumber: 9
    }
  }), children), footerSlot ? /*#__PURE__*/React.createElement(CCardFooter, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 57,
      columnNumber: 9
    }
  }, footerSlot) : '');
  return /*#__PURE__*/React.createElement(Tag, _extends({}, attributes, {
    className: classes,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 65,
      columnNumber: 5
    }
  }), children);
};

CCard.sharedPropTypes = {
  align: PropTypes.string,
  color: PropTypes.string,
  borderColor: PropTypes.string,
  textColor: PropTypes.string,
  accentColor: PropTypes.string,
  bodyClassName: PropTypes.string,
  bodyProps: PropTypes.object
};
CCard.propTypes = process.env.NODE_ENV !== "production" ? _extends({}, CCard.sharedPropTypes, {
  tag: tagPropType,
  className: PropTypes.string,
  cssModule: PropTypes.object,
  custom: PropTypes.bool,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  align: PropTypes.string,
  color: PropTypes.string,
  borderColor: PropTypes.string,
  textColor: PropTypes.string,
  accentColor: PropTypes.string,
  bodyClassName: PropTypes.string,
  bodyProps: PropTypes.object,
  headerSlot: PropTypes.node,
  footerSlot: PropTypes.node
}) : {};
CCard.defaultProps = {
  tag: 'div'
};
export default CCard;