var _this = this,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CCarousel.js";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useState, useRef } from 'react';
import PropTypes from 'prop-types';
import CCarouselCustom from './CCarouselCustom';
import CCarouselItem from './CCarouselItem';
import CCarouselControl from './CCarouselControl';
import CCarouselIndicators from './CCarouselIndicators';
import CCarouselCaption from './CCarouselCaption'; //component - CoreUI / CCarousel

var CCarousel = function CCarousel(props) {
  var custom = props.custom,
      autoPlay = props.autoPlay,
      indicators = props.indicators,
      controls = props.controls,
      items = props.items,
      goToIndex = props.goToIndex;

  var _useState = useState(props.defaultOpen || false),
      activeIndex = _useState[0],
      setActiveIndex = _useState[1];

  var fields = useRef({
    animating: false
  }).current;

  if (!custom) {
    var onExiting = function onExiting() {
      fields.animating = true;
    };

    var onExited = function onExited() {
      fields.animating = false;
    };

    var next = function next() {
      if (fields.animating) return;
      var nextIndex = activeIndex === props.items.length - 1 ? 0 : activeIndex + 1;
      setActiveIndex(nextIndex);
    };

    var previous = function previous() {
      if (fields.animating) return;
      var nextIndex = activeIndex === 0 ? props.items.length - 1 : activeIndex - 1;
      setActiveIndex(nextIndex);
    };

    var toIndex = function toIndex(newIndex) {
      if (fields.animating) return;
      setActiveIndex(newIndex);
    }; //render


    var slides = items.map(function (item) {
      return /*#__PURE__*/React.createElement(CCarouselItem, {
        onExiting: onExiting,
        onExited: onExited,
        key: item.src,
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 58,
          columnNumber: 9
        }
      }, /*#__PURE__*/React.createElement("img", {
        className: "d-block w-100",
        src: item.src,
        alt: item.altText,
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 63,
          columnNumber: 11
        }
      }), /*#__PURE__*/React.createElement(CCarouselCaption, {
        captionText: item.caption,
        captionHeader: item.header || item.caption,
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 64,
          columnNumber: 11
        }
      }));
    });
    return /*#__PURE__*/React.createElement(CCarouselCustom, _extends({
      activeIndex: activeIndex,
      next: next,
      previous: previous,
      ride: autoPlay ? 'carousel' : undefined
    }, props, {
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 70,
        columnNumber: 7
      }
    }), indicators && /*#__PURE__*/React.createElement(CCarouselIndicators, {
      items: items,
      activeIndex: props.activeIndex || activeIndex,
      onClickHandler: goToIndex || toIndex,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 77,
        columnNumber: 24
      }
    }), slides, controls && /*#__PURE__*/React.createElement(CCarouselControl, {
      direction: "prev",
      directionText: "Previous",
      onClickHandler: props.previous || previous,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 83,
        columnNumber: 22
      }
    }), controls && /*#__PURE__*/React.createElement(CCarouselControl, {
      direction: "next",
      directionText: "Next",
      onClickHandler: props.next || next,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 88,
        columnNumber: 22
      }
    }));
  }

  return /*#__PURE__*/React.createElement(CCarouselCustom, _extends({}, props, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 99,
      columnNumber: 5
    }
  }));
};

CCarousel.propTypes = process.env.NODE_ENV !== "production" ? {
  custom: PropTypes.bool,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  items: PropTypes.array,
  indicators: PropTypes.bool,
  defaultOpen: PropTypes.bool,
  controls: PropTypes.bool,
  autoPlay: PropTypes.bool,
  activeIndex: PropTypes.number,
  next: PropTypes.func,
  previous: PropTypes.func,
  goToIndex: PropTypes.func
} : {};
CCarousel.defaultProps = {
  controls: true,
  indicators: true,
  autoPlay: true
};
export default CCarousel;