var _this = this,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CDropdownToggle.js";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useContext } from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { tagPropType, mapToCssModules } from './Shared/helper.js';
import { Reference } from 'react-popper';
import CButton from './CButton';
import { Context } from './CDropdownCustom'; //component - CoreUI / CDropdownToggle

var CDropdownToggle = function CDropdownToggle(props) {
  var className = props.className,
      color = props.color,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      caret = props.caret,
      split = props.split,
      nav = props.nav,
      header = props.header,
      tag = props.tag,
      togglerHtml = props.togglerHtml,
      attributes = _objectWithoutPropertiesLoose(props, ["className", "color", "cssModule", "innerRef", "caret", "split", "nav", "header", "tag", "togglerHtml"]);

  var context = useContext(Context);

  var onClick = function onClick(e) {
    if (props.disabled) {
      e.preventDefault();
      return;
    }

    if (props.nav && !props.tag) {
      e.preventDefault();
    }

    if (props.onClick) {
      props.onClick(e);
    }

    context.toggle(e);
  }; //render


  var ariaLabel = attributes['aria-label'] || 'Toggle Dropdown';
  var classes = mapToCssModules(classNames(className, {
    'dropdown-toggle': caret || split,
    'dropdown-toggle-split': split,
    'nav-link': nav && !header,
    'c-header-nav-link': nav && header
  }), cssModule);
  var children = togglerHtml || attributes.children || /*#__PURE__*/React.createElement("span", {
    className: "sr-only",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 58,
      columnNumber: 58
    }
  }, ariaLabel);
  var Tag;
  var isButton = false;

  if (nav && !tag) {
    Tag = 'a';
    attributes.href = '#';
  } else if (!tag) {
    Tag = CButton;
    attributes.color = color;
    attributes.cssModule = cssModule;
    isButton = true;
  } else {
    Tag = tag;
  }

  if (context.inNavbar) {
    if (isButton) return /*#__PURE__*/React.createElement(Tag, _extends({}, attributes, {
      className: classes,
      onClick: onClick,
      "aria-expanded": context.isOpen,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 78,
        columnNumber: 9
      }
    }), children);else return /*#__PURE__*/React.createElement(Tag, _extends({}, attributes, {
      className: classes,
      onClick: onClick,
      "aria-expanded": context.isOpen,
      ref: innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 89,
        columnNumber: 9
      }
    }), children);
  }

  return /*#__PURE__*/React.createElement(Reference, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 102,
      columnNumber: 5
    }
  }, function (_ref) {
    var ref = _ref.ref;
    return /*#__PURE__*/React.createElement(Tag, _extends({}, attributes, {
      className: classes,
      onClick: onClick,
      "aria-expanded": context.isOpen,
      ref: innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 104,
        columnNumber: 9
      }
    }), children);
  });
};

CDropdownToggle.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: tagPropType,
  children: PropTypes.node,
  className: PropTypes.string,
  cssModule: PropTypes.object,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  caret: PropTypes.bool,
  color: PropTypes.string,
  disabled: PropTypes.bool,
  onClick: PropTypes.func,
  'aria-haspopup': PropTypes.bool,
  split: PropTypes.bool,
  togglerHtml: PropTypes.node,
  nav: PropTypes.bool,
  header: PropTypes.bool
} : {};
CDropdownToggle.defaultProps = {
  'aria-haspopup': true
};
export default CDropdownToggle;