var _this = this,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CLink.js";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { mapToCssModules } from './Shared/helper.js';
import { NavLink } from 'react-router-dom'; //component - CoreUI / CLink

var CLink = function CLink(props) {
  var className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      active = props.active,
      href = props.href,
      onClick = props.onClick,
      rest = _objectWithoutPropertiesLoose(props, ["className", "cssModule", "innerRef", "active", "href", "onClick"]);

  var to = rest ? rest.to : null;

  var click = function click(e) {
    if (!href && !to) {
      e.preventDefault();
    }

    onClick && onClick(e);
  }; // render


  var classes = mapToCssModules(classNames(className, active ? 'active' : null), cssModule);
  return to ? /*#__PURE__*/React.createElement(NavLink, _extends({}, rest, {
    className: classes,
    onClick: click,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 37,
      columnNumber: 5
    }
  })) : /*#__PURE__*/React.createElement("a", _extends({
    href: href || '#',
    className: classes
  }, rest, {
    onClick: click,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 44,
      columnNumber: 5
    }
  }));
};

CLink.propTypes = process.env.NODE_ENV !== "production" ? _extends({
  className: PropTypes.string,
  cssModule: PropTypes.object,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  active: PropTypes.bool,
  href: PropTypes.string,
  onClick: PropTypes.func
}, NavLink.propTypes, {
  to: PropTypes.oneOfType([PropTypes.object, PropTypes.string, PropTypes.func])
}) : {};

CLink.sortAttributes = function (attributesToSort) {
  var attributes = {};
  var linkProps = {};
  Object.entries(attributesToSort || {}).forEach(function (_ref) {
    var key = _ref[0],
        value = _ref[1];

    if (Object.keys(CLink.propTypes).includes(key)) {
      linkProps[key] = value;
    } else {
      attributes[key] = value;
    }
  });
  return {
    linkProps: linkProps,
    attributes: attributes
  };
};

export default CLink;