var _this = this,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CPagination.js";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { tagPropType, mapToCssModules } from './Shared/helper.js';
import CPaginationItem from './CPaginationItem';
import CPaginationLink from './CPaginationLink';
export var Context = React.createContext({}); //component - CoreUI / CPagination

var CPagination = function CPagination(props) {
  var _classNames;

  var Tag = props.tag,
      children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      custom = props.custom,
      innerRef = props.innerRef,
      listClassName = props.listClassName,
      pageFrom = props.pageFrom,
      pageTo = props.pageTo,
      pageMin = props.pageMin,
      pageMax = props.pageMax,
      activePage = props.activePage,
      size = props.size,
      firstButtonHtml = props.firstButtonHtml,
      previousButtonHtml = props.previousButtonHtml,
      nextButtonHtml = props.nextButtonHtml,
      lastButtonHtml = props.lastButtonHtml,
      hideDots = props.hideDots,
      ListTag = props.listTag,
      label = props['aria-label'],
      listProps = props.listProps,
      onClick = props.onClick,
      attributes = _objectWithoutPropertiesLoose(props, ["tag", "children", "className", "cssModule", "custom", "innerRef", "listClassName", "pageFrom", "pageTo", "pageMin", "pageMax", "activePage", "size", "firstButtonHtml", "previousButtonHtml", "nextButtonHtml", "lastButtonHtml", "hideDots", "listTag", "aria-label", "listProps", "onClick"]);

  var paginationClick = function paginationClick(e, type, n) {
    onClick && onClick(e, type, n);
  }; //render


  var classes = mapToCssModules(classNames(className), cssModule);
  var listClasses = mapToCssModules(classNames(listClassName, 'pagination', (_classNames = {}, _classNames["pagination-" + size] = !!size, _classNames)), cssModule);
  var autoChildren;

  if (!custom) {
    var list = [];

    for (var i = pageFrom; i <= pageTo; i++) {
      list.push( /*#__PURE__*/React.createElement(CPaginationItem, {
        custom: true,
        key: i,
        active: activePage == i ? true : false,
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 67,
          columnNumber: 17
        }
      }, /*#__PURE__*/React.createElement(CPaginationLink, {
        type: "number",
        n: i,
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 67,
          columnNumber: 83
        }
      }, i)));
    }

    var pagesBefore = pageFrom > pageMin;
    var pagesAfter = pageTo < pageMax;
    autoChildren = /*#__PURE__*/React.createElement(React.Fragment, {
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 71,
        columnNumber: 7
      }
    }, pagesBefore && firstButtonHtml ? /*#__PURE__*/React.createElement(CPaginationItem, {
      custom: true,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 72,
        columnNumber: 39
      }
    }, /*#__PURE__*/React.createElement(CPaginationLink, {
      type: "first",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 72,
        columnNumber: 63
      }
    }, firstButtonHtml)) : '', pagesBefore && previousButtonHtml ? /*#__PURE__*/React.createElement(CPaginationItem, {
      custom: true,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 73,
        columnNumber: 42
      }
    }, /*#__PURE__*/React.createElement(CPaginationLink, {
      type: "previous",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 73,
        columnNumber: 66
      }
    }, previousButtonHtml)) : '', !hideDots && pagesBefore ? /*#__PURE__*/React.createElement(CPaginationItem, {
      custom: true,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 74,
        columnNumber: 33
      }
    }, /*#__PURE__*/React.createElement(CPaginationLink, {
      type: "less",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 74,
        columnNumber: 57
      }
    }, "...")) : '', list, !hideDots && pagesAfter ? /*#__PURE__*/React.createElement(CPaginationItem, {
      custom: true,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 76,
        columnNumber: 32
      }
    }, /*#__PURE__*/React.createElement(CPaginationLink, {
      type: "more",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 76,
        columnNumber: 56
      }
    }, "...")) : '', pagesAfter && nextButtonHtml ? /*#__PURE__*/React.createElement(CPaginationItem, {
      custom: true,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 77,
        columnNumber: 37
      }
    }, /*#__PURE__*/React.createElement(CPaginationLink, {
      type: "next",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 77,
        columnNumber: 61
      }
    }, nextButtonHtml)) : '', pagesAfter && lastButtonHtml ? /*#__PURE__*/React.createElement(CPaginationItem, {
      custom: true,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 78,
        columnNumber: 37
      }
    }, /*#__PURE__*/React.createElement(CPaginationLink, {
      type: "last",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 78,
        columnNumber: 61
      }
    }, lastButtonHtml)) : '');
  }

  return /*#__PURE__*/React.createElement(Context.Provider, {
    value: {
      paginationClick: paginationClick
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 84,
      columnNumber: 5
    }
  }, /*#__PURE__*/React.createElement(Tag, _extends({}, attributes, {
    className: classes,
    "aria-label": label,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 87,
      columnNumber: 7
    }
  }), /*#__PURE__*/React.createElement(ListTag, _extends({
    className: listClasses
  }, listProps, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 88,
      columnNumber: 9
    }
  }), autoChildren || children)));
};

CPagination.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: tagPropType,
  children: PropTypes.node,
  className: PropTypes.string,
  cssModule: PropTypes.object,
  custom: PropTypes.bool,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  pageMin: PropTypes.number,
  pageMax: PropTypes.number,
  pageFrom: PropTypes.number,
  pageTo: PropTypes.number,
  activePage: PropTypes.number,
  size: PropTypes.string,
  listTag: tagPropType,
  hideDots: PropTypes.bool,
  hideArrows: PropTypes.bool,
  hideDoubleArrows: PropTypes.bool,
  firstButtonHtml: PropTypes.oneOfType([PropTypes.object, PropTypes.string]),
  previousButtonHtml: PropTypes.oneOfType([PropTypes.object, PropTypes.string]),
  nextButtonHtml: PropTypes.oneOfType([PropTypes.object, PropTypes.string]),
  lastButtonHtml: PropTypes.oneOfType([PropTypes.object, PropTypes.string]),
  'aria-label': PropTypes.string,
  listClassName: PropTypes.string,
  listProps: PropTypes.object,
  onClick: PropTypes.func
} : {};
CPagination.defaultProps = {
  tag: 'nav',
  listTag: 'ul',
  'aria-label': 'pagination',
  pageFrom: 2,
  pageTo: 3,
  pageMin: 1,
  pageMax: 5,
  activePage: 2,
  firstButtonHtml: /*#__PURE__*/React.createElement(React.Fragment, {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 134,
      columnNumber: 20
    }
  }, "\xAB"),
  previousButtonHtml: /*#__PURE__*/React.createElement(React.Fragment, {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 135,
      columnNumber: 23
    }
  }, "\u2039"),
  nextButtonHtml: /*#__PURE__*/React.createElement(React.Fragment, {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 136,
      columnNumber: 19
    }
  }, "\u203A"),
  lastButtonHtml: /*#__PURE__*/React.createElement(React.Fragment, {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 137,
      columnNumber: 19
    }
  }, "\xBB")
};
export default CPagination;