var _this = this,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CWidgetProgressIcon.js";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { mapToCssModules } from './Shared/helper.js'; //

import CCard from './CCard';
import CProgress from './CProgress';
import { CIcon } from '@coreui/icons-react'; //component - CoreUI / CWidget4

var CWidgetProgressIcon = function CWidgetProgressIcon(props) {
  var children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      header = props.header,
      value = props.value,
      icon = props.icon,
      color = props.color,
      invert = props.invert,
      attributes = _objectWithoutPropertiesLoose(props, ["children", "className", "cssModule", "header", "value", "icon", "color", "invert"]);

  var progress = {
    style: '',
    color: color,
    value: value
  };
  var card = {
    style: '',
    bgColor: '',
    icon: icon
  };

  if (invert) {
    progress.style = 'progress-white';
    progress.color = '';
    card.style = 'text-white';
    card.bgColor = 'bg-' + color;
  }

  var classes = mapToCssModules(classNames(className, card.style, card.bgColor), cssModule);
  progress.style = classNames('progress-xs mt-3 mb-0', progress.style);
  return /*#__PURE__*/React.createElement(CCard, _extends({}, attributes, {
    className: classes,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 42,
      columnNumber: 5
    }
  }), /*#__PURE__*/React.createElement("div", {
    className: "text-muted text-right mb-4",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 43,
      columnNumber: 7
    }
  }, /*#__PURE__*/React.createElement(CIcon, {
    name: card.icon,
    size: "xl",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 44,
      columnNumber: 9
    }
  })), /*#__PURE__*/React.createElement("div", {
    className: "text-value-lg",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 46,
      columnNumber: 7
    }
  }, header), /*#__PURE__*/React.createElement("small", {
    className: "text-muted text-uppercase font-weight-bold",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 47,
      columnNumber: 7
    }
  }, children), /*#__PURE__*/React.createElement(CProgress, {
    className: progress.style,
    color: progress.color,
    value: progress.value,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 48,
      columnNumber: 7
    }
  }));
};

CWidgetProgressIcon.propTypes = process.env.NODE_ENV !== "production" ? {
  children: PropTypes.node,
  className: PropTypes.string,
  cssModule: PropTypes.object,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  header: PropTypes.string,
  icon: PropTypes.string,
  color: PropTypes.string,
  value: PropTypes.string,
  invert: PropTypes.bool
} : {};
CWidgetProgressIcon.defaultProps = {
  header: '87.500',
  icon: 'cil-people',
  color: 'info',
  value: '25',
  children: 'Visitors',
  invert: false
};
export default CWidgetProgressIcon;