"use strict";

exports.__esModule = true;
exports["default"] = exports.Context = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactPopper = require("react-popper");

var _helper = require("./Shared/helper.js");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\-CPopperContent.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

var Context = _react["default"].createContext({}); //component - CoreUI / CPopperContentWrapper
// new popper


exports.Context = Context;

var CPopperContentWrapper = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(CPopperContentWrapper, _React$Component);

  function CPopperContentWrapper() {
    return _React$Component.apply(this, arguments) || this;
  }

  var _proto = CPopperContentWrapper.prototype;

  _proto.getChildContext = function getChildContext() {
    return this.context;
  };

  _proto.render = function render() {
    return this.props.children;
  };

  return CPopperContentWrapper;
}(_react["default"].Component);

CPopperContentWrapper.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes["default"].node.isRequired
} : {};
CPopperContentWrapper.contextType = Context;
CPopperContentWrapper.childContextTypes = {
  popperManager: _propTypes["default"].object.isRequired
}; //component - CoreUI / CPopperContent

var CPopperContent = function CPopperContent(props) {
  var _useState = (0, _react.useState)(),
      placement = _useState[0],
      setPlacement = _useState[1];

  var fields = (0, _react.useRef)({
    firstRender: true
  }).current;

  var setTargetNode = function setTargetNode(node) {
    fields.targetNode = node;
  };

  var getTargetNode = function getTargetNode() {
    return fields.targetNode;
  };

  var getContainerNode = function getContainerNode() {
    return (0, _helper.getTarget)(props.container);
  };

  var getRef = function getRef(ref) {
    fields._element = ref;
    props.innerRef && props.innerRef();
  };

  var handlePlacementChange = function handlePlacementChange(data) {
    if (placement !== data.placement) {
      setPlacement(data.placement);
    }

    return data;
  }; //effect - update


  (0, _react.useEffect)(function () {
    if (fields.firstRender) return;

    if (fields._element && fields._element.childNodes && fields._element.childNodes[0] && fields._element.childNodes[0].focus) {
      fields._element.childNodes[0].focus();
    }
  });
  (0, _react.useEffect)(function () {
    fields.firstRender = false;
  }, []); //render

  var renderChildren = function renderChildren() {
    var tag = props.tag,
        children = props.children,
        className = props.className,
        cssModule = props.cssModule,
        flip = props.flip,
        offset = props.offset,
        fallbackPlacement = props.fallbackPlacement,
        placementPrefix = props.placementPrefix,
        _arrowClassName = props.arrowClassName,
        hideArrow = props.hideArrow,
        modifiers = props.modifiers,
        boundariesElement = props.boundariesElement,
        attributes = _objectWithoutPropertiesLoose(props, ["tag", "children", "className", "cssModule", "flip", "offset", "fallbackPlacement", "placementPrefix", "arrowClassName", "hideArrow", "modifiers", "boundariesElement"]);

    var arrowClassName = (0, _helper.mapToCssModules)((0, _classnames["default"])('arrow', _arrowClassName), cssModule);
    var placement2 = (placement || attributes.placement).split('-')[0];
    var popperClassName = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, //8 _popperClassName
    placementPrefix ? placementPrefix + "-" + placement2 : placement2), props.cssModule);

    var extendedModifiers = _extends({
      offset: {
        offset: offset
      },
      flip: {
        enabled: flip,
        behavior: fallbackPlacement
      },
      preventOverflow: {
        boundariesElement: boundariesElement
      },
      update: {
        enabled: true,
        order: 950,
        fn: handlePlacementChange
      }
    }, modifiers);

    return /*#__PURE__*/_react["default"].createElement(Context.Provider, {
      value: {
        popperManager: {
          setTargetNode: setTargetNode,
          getTargetNode: getTargetNode
        }
      },
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 126,
        columnNumber: 7
      }
    });
    /*
    https://github.com/popperjs/react-popper
      manager - wrapper, komunikacja
    popper - okno // The Popper component accepts the properties children, placement, modifiers and strategy.
    reference - klikacz
    //
    z createPortal - przenosi
    virtualReferenceElement - gdy przekazujemy referencje
        import { Manager, Reference, Popper } from 'react-popper';
    const Example = () => (
      <Manager>
        <Reference>
          {({ ref }) => (
            <button type="button" ref={ref}>
              Reference element
            </button>
          )}
        </Reference>
        <Popper placement="right">
          {({ ref, style, placement, arrowProps }) => (
            <div ref={ref} style={style} data-placement={placement}>
              Popper element
              <div ref={arrowProps.ref} style={arrowProps.style} />
            </div>
          )}
        </Popper>
      </Manager>
      //
      <Context.Provider value={{popperManager: {
      setTargetNode: setTargetNode,
      getTargetNode: getTargetNode,
    }}}>
      <CPopperContentWrapper>
        <ReactPopper
          modifiers={extendedModifiers}
          {...attributes}
          component={tag}
          className={popperClassName}
          x-placement={placement || attributes.placement}
        >
          {children}
          {!hideArrow && <Arrow className={arrowClassName} />}
        </ReactPopper>
      </CPopperContentWrapper>
    </Context.Provider>
      Core
    info:
    Komponent			{ }					użycie
    CPopperContent		Arrow, Popper			CDropdownCustom, CPopperTargetHelper, CTooltipPopoverWrapper
    <ReactPopper
            modifiers={extendedModifiers}
            {...attributes}
            component={tag}
            className={popperClassName}
            x-placement={placement || attributes.placement}
          >
            {children}
            {!hideArrow && <Arrow className={arrowClassName} />}
        </ReactPopper>
    //
    modifiers = {
      offset: { offset },
      flip: { enabled: flip, behavior: fallbackPlacement },
      preventOverflow: { boundariesElement },
      update: {
        enabled: true,
        order: 950,
        fn: handlePlacementChange,
      },
      ...modifiers,
    };
    CDropdownCustom		Manager				CDropdown, CDropdownItem, CDopdownMenu, CDropdownToggle, CToggler
    <Manager {...attributes} className={classes} onKeyDown={handleKeyDown} ref={reference} />
    CDropdownMenu		Popper				CWidgetSimple
       <Tag
      tabIndex="-1"
      role="menu"
      {...attributes}
      aria-hidden={!context.isOpen}
      className={classes}
      x-placement={attributes.placement}
      ref={innerRef}
     />
    CDropdownToggle		Target				CWidgetSimple
       <Target
      {...attributes}
      className={classes}
      component={Tag}
      onClick={onClick}
      aria-expanded={context.isOpen}
      ref={innerRef}
    >
      {children}
    </Target>
      */
  };

  renderChildren.propTypes = process.env.NODE_ENV !== "production" ? {
    tag: _helper.tagPropType,
    children: _propTypes["default"].node.isRequired,
    className: _propTypes["default"].string,
    cssModule: _propTypes["default"].object,
    //
    innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
    placement: _propTypes["default"].string,
    placementPrefix: _propTypes["default"].string,
    arrowClassName: _propTypes["default"].string,
    hideArrow: _propTypes["default"].bool,
    show: _propTypes["default"].bool.isRequired,
    offset: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    fallbackPlacement: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].array]),
    flip: _propTypes["default"].bool,
    container: _helper.targetPropType,
    target: _helper.targetPropType.isRequired,
    modifiers: _propTypes["default"].object,
    boundariesElement: _propTypes["default"].oneOfType([_propTypes["default"].string, _helper.DOMElement])
  } : {};
  setTargetNode((0, _helper.getTarget)(props.target));

  if (props.show) {
    return props.container === 'inline' ? renderChildren() : _reactDom["default"].createPortal( /*#__PURE__*/_react["default"].createElement("div", {
      ref: getRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 280,
        columnNumber: 30
      }
    }, renderChildren()), getContainerNode());
  }

  return null;
};

CPopperContent.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  children: _propTypes["default"].node.isRequired,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  placement: _propTypes["default"].string,
  placementPrefix: _propTypes["default"].string,
  arrowClassName: _propTypes["default"].string,
  hideArrow: _propTypes["default"].bool,
  show: _propTypes["default"].bool.isRequired,
  offset: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  fallbackPlacement: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].array]),
  flip: _propTypes["default"].bool,
  container: _helper.targetPropType,
  target: _helper.targetPropType.isRequired,
  modifiers: _propTypes["default"].object,
  boundariesElement: _propTypes["default"].oneOfType([_propTypes["default"].string, _helper.DOMElement])
} : {};
CPopperContent.defaultProps = {
  boundariesElement: 'scrollParent',
  placement: 'auto',
  hideArrow: false,
  show: false,
  offset: 0,
  fallbackPlacement: 'flip',
  flip: true,
  container: 'body',
  modifiers: {}
};
var _default = CPopperContent;
exports["default"] = _default;