"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactRouterDom = require("react-router-dom");

var _CBreadcrumbCustom = _interopRequireDefault(require("./CBreadcrumbCustom"));

var _CBreadcrumbItem = _interopRequireDefault(require("./CBreadcrumbItem"));

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CBreadcrumb.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var routes;

var getPaths = function getPaths(pathname) {
  var paths = ['/'];
  if (pathname === '/') return paths;
  pathname.split('/').reduce(function (prev, curr) {
    var currPath = prev + "/" + curr;
    paths.push(currPath);
    return currPath;
  });
  return paths;
};

var findRouteName = function findRouteName(url) {
  var aroute = routes.find(function (route) {
    return (0, _reactRouterDom.matchPath)(url, {
      path: route.path,
      exact: route.exact
    });
  });
  return aroute && aroute.name ? aroute.name : null;
}; //component - CoreUI / CBreadcrumbRouteItem


var CBreadcrumbRouteItem = function CBreadcrumbRouteItem(_ref) {
  var match = _ref.match;
  var routeName = findRouteName(match.url);

  if (routeName) {
    return match.isExact ? /*#__PURE__*/_react["default"].createElement(_CBreadcrumbItem["default"], {
      active: true,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 33,
        columnNumber: 9
      }
    }, routeName) : /*#__PURE__*/_react["default"].createElement(_CBreadcrumbItem["default"], {
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 35,
        columnNumber: 9
      }
    }, /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Link, {
      to: match.url || '',
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 36,
        columnNumber: 11
      }
    }, routeName));
  }

  return null;
};

CBreadcrumbRouteItem.propTypes = process.env.NODE_ENV !== "production" ? {
  match: _propTypes["default"].shape({
    url: _propTypes["default"].string,
    isExact: _propTypes["default"].bool
  })
} : {}; //component - CoreUI / CBreadcrumbRouter

var postItems;

var CBreadcrumbRouter = function CBreadcrumbRouter(args) {
  var paths = getPaths(args.location.pathname);
  var items = paths.map(function (path, i) {
    return /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Route, {
      key: i.toString(),
      path: path,
      component: CBreadcrumbRouteItem,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 60,
        columnNumber: 18
      }
    });
  });
  if (postItems) items.push(postItems); // render

  return items;
  /*
  return (
    <CBreadcrumbCustom>
      {items}
    </CBreadcrumbCustom>
  );
  */
}; //component - CoreUI / CBreadcrumb


var CBreadcrumb = function CBreadcrumb(props) {
  var children = props.children,
      className = props.className,
      custom = props.custom,
      routesProps = props.routesProps,
      attributes = _objectWithoutPropertiesLoose(props, ["children", "className", "custom", "routesProps"]);

  if (children) postItems = children;else {
    postItems = null;
  }
  routes = props.appRoutes; //render

  delete attributes.appRoutes;
  var classes = (0, _classnames["default"])(className);

  if (!custom) {
    return /*#__PURE__*/_react["default"].createElement(_CBreadcrumbCustom["default"], _extends({}, attributes, {
      listClassName: classes,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 106,
        columnNumber: 7
      }
    }), /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Route, _extends({
      path: "/:path",
      component: CBreadcrumbRouter
    }, routesProps, {
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 107,
        columnNumber: 9
      }
    })));
  }

  return /*#__PURE__*/_react["default"].createElement(_CBreadcrumbCustom["default"], _extends({}, attributes, {
    listClassName: classes,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 113,
      columnNumber: 5
    }
  }), children);
};

CBreadcrumb.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].string]),
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  custom: _propTypes["default"].bool,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  appRoutes: _propTypes["default"].any,
  match: _propTypes["default"].object,
  routesProps: _propTypes["default"].object
} : {};
CBreadcrumb.defaultProps = {
  tag: 'div',
  className: '',
  appRoutes: [{
    path: '/',
    exact: true,
    name: 'Home',
    component: null
  }]
};
var _default = CBreadcrumb;
exports["default"] = _default;
module.exports = exports.default;