"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _CCardBody = _interopRequireDefault(require("./CCardBody"));

var _CCardHeader = _interopRequireDefault(require("./CCardHeader"));

var _CCardFooter = _interopRequireDefault(require("./CCardFooter"));

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CCard.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CCard
var CCard = function CCard(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      custom = props.custom,
      innerRef = props.innerRef,
      color = props.color,
      textColor = props.textColor,
      borderColor = props.borderColor,
      accentColor = props.accentColor,
      headerSlot = props.headerSlot,
      footerSlot = props.footerSlot,
      align = props.align,
      bodyClassName = props.bodyClassName,
      bodyProps = props.bodyProps,
      attributes = _objectWithoutPropertiesLoose(props, ["tag", "children", "className", "cssModule", "custom", "innerRef", "color", "textColor", "borderColor", "accentColor", "headerSlot", "footerSlot", "align", "bodyClassName", "bodyProps"]); //render


  var classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, 'card', align ? "text-" + align : false, textColor ? "text-" + textColor : false, color ? "bg-" + color : false, borderColor ? "border-" + borderColor : false, accentColor ? "card-accent-" + accentColor : false), cssModule);
  if (!custom) return /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, attributes, {
    className: classes,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 47,
      columnNumber: 7
    }
  }), headerSlot ? /*#__PURE__*/_react["default"].createElement(_CCardHeader["default"], {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 49,
      columnNumber: 9
    }
  }, headerSlot) : '', /*#__PURE__*/_react["default"].createElement(_CCardBody["default"], _extends({}, bodyProps, {
    className: bodyClassName,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 53,
      columnNumber: 9
    }
  }), children), footerSlot ? /*#__PURE__*/_react["default"].createElement(_CCardFooter["default"], {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 57,
      columnNumber: 9
    }
  }, footerSlot) : '');
  return /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, attributes, {
    className: classes,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 65,
      columnNumber: 5
    }
  }), children);
};

CCard.sharedPropTypes = {
  align: _propTypes["default"].string,
  color: _propTypes["default"].string,
  borderColor: _propTypes["default"].string,
  textColor: _propTypes["default"].string,
  accentColor: _propTypes["default"].string,
  bodyClassName: _propTypes["default"].string,
  bodyProps: _propTypes["default"].object
};
CCard.propTypes = process.env.NODE_ENV !== "production" ? _extends({}, CCard.sharedPropTypes, {
  tag: _helper.tagPropType,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  custom: _propTypes["default"].bool,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  align: _propTypes["default"].string,
  color: _propTypes["default"].string,
  borderColor: _propTypes["default"].string,
  textColor: _propTypes["default"].string,
  accentColor: _propTypes["default"].string,
  bodyClassName: _propTypes["default"].string,
  bodyProps: _propTypes["default"].object,
  headerSlot: _propTypes["default"].node,
  footerSlot: _propTypes["default"].node
}) : {};
CCard.defaultProps = {
  tag: 'div'
};
var _default = CCard;
exports["default"] = _default;
module.exports = exports.default;