"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CCarouselControl.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CCarouselControl
var CCarouselControl = function CCarouselControl(props) {
  var className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      direction = props.direction,
      onClickHandler = props.onClickHandler,
      directionText = props.directionText,
      attributes = _objectWithoutPropertiesLoose(props, ["className", "cssModule", "innerRef", "direction", "onClickHandler", "directionText"]);

  var onClick = function onClick(e) {
    e.preventDefault();
    onClickHandler();
  }; //render


  var anchorClasses = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, "carousel-control-" + direction), cssModule);
  var iconClasses = (0, _helper.mapToCssModules)((0, _classnames["default"])("carousel-control-" + direction + "-icon"), cssModule);
  var screenReaderClasses = (0, _helper.mapToCssModules)((0, _classnames["default"])('sr-only'), cssModule);
  return /*#__PURE__*/_react["default"].createElement("a", _extends({}, attributes, {
    className: anchorClasses,
    role: "button",
    tabIndex: "0",
    onClick: onClick,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 42,
      columnNumber: 5
    }
  }), /*#__PURE__*/_react["default"].createElement("span", {
    className: iconClasses,
    "aria-hidden": "true",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 50,
      columnNumber: 7
    }
  }), /*#__PURE__*/_react["default"].createElement("span", {
    className: screenReaderClasses,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 51,
      columnNumber: 7
    }
  }, directionText || direction));
};

CCarouselControl.propTypes = process.env.NODE_ENV !== "production" ? {
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  direction: _propTypes["default"].oneOf(['prev', 'next']).isRequired,
  onClickHandler: _propTypes["default"].func.isRequired,
  directionText: _propTypes["default"].string
} : {};
var _default = CCarouselControl;
exports["default"] = _default;
module.exports = exports.default;