"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CCarouselIndicators.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CCarouselIndicators
var CCarouselIndicators = function CCarouselIndicators(props) {
  var className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      items = props.items,
      activeIndex = props.activeIndex,
      onClickHandler = props.onClickHandler,
      itemProps = props.itemProps,
      attributes = _objectWithoutPropertiesLoose(props, ["className", "cssModule", "innerRef", "items", "activeIndex", "onClickHandler", "itemProps"]); //render


  var listClasses = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, 'carousel-indicators'), cssModule);
  var indicators = items.map(function (item, idx) {
    var indicatorClasses = (0, _helper.mapToCssModules)((0, _classnames["default"])({
      'active': activeIndex === idx
    }), cssModule);
    return /*#__PURE__*/_react["default"].createElement("li", _extends({
      key: "" + (item.key || Object.values(item).join('')),
      onClick: function onClick(e) {
        e.preventDefault();
        onClickHandler(idx);
      },
      className: indicatorClasses
    }, itemProps, {
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 34,
        columnNumber: 7
      }
    }));
  });
  return /*#__PURE__*/_react["default"].createElement("ol", _extends({}, attributes, {
    className: listClasses,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 46,
      columnNumber: 5
    }
  }), indicators);
};

CCarouselIndicators.propTypes = process.env.NODE_ENV !== "production" ? {
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  items: _propTypes["default"].array.isRequired,
  activeIndex: _propTypes["default"].number.isRequired,
  onClickHandler: _propTypes["default"].func.isRequired,
  itemProps: _propTypes["default"].object
} : {};
var _default = CCarouselIndicators;
exports["default"] = _default;
module.exports = exports.default;