"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _reactTransitionGroup = require("react-transition-group");

var _CCarouselCustom = require("./CCarouselCustom");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CCarouselItem.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CCarouselItem
var CCarouselItem = function CCarouselItem(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      isIn = props["in"],
      slide = props.slide,
      itemProps = props.itemProps,
      transitionProps = _objectWithoutPropertiesLoose(props, ["tag", "children", "className", "cssModule", "innerRef", "in", "slide", "itemProps"]);

  var context = (0, _react.useContext)(_CCarouselCustom.Context);

  var _useState = (0, _react.useState)(false),
      startAnimation = _useState[0],
      setStartAnimation = _useState[1];

  var onEnter = function onEnter(node, isAppearing) {
    setStartAnimation(false);
    props.onEnter(node, isAppearing);
  };

  var onEntering = function onEntering(node, isAppearing) {
    var offsetHeight = node.offsetHeight;
    setStartAnimation(true);
    props.onEntering(node, isAppearing);
    return offsetHeight;
  };

  var onExit = function onExit(node) {
    setStartAnimation(false);
    props.onExit(node);
  };

  var onExiting = function onExiting(node) {
    setStartAnimation(true);
    node.dispatchEvent(new CustomEvent('slide.bs.carousel'));
    props.onExiting(node);
  };

  var onExited = function onExited(node) {
    node.dispatchEvent(new CustomEvent('slid.bs.carousel'));
    props.onExited(node);
  }; //render


  return /*#__PURE__*/_react["default"].createElement(_reactTransitionGroup.Transition, _extends({}, transitionProps, {
    enter: slide,
    exit: slide,
    "in": isIn,
    onEnter: onEnter,
    onEntering: onEntering,
    onExit: onExit,
    onExiting: onExiting,
    onExited: onExited,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 60,
      columnNumber: 5
    }
  }), function (status) {
    var direction = context.direction;
    var isActive = status === _helper.TransitionStatuses.ENTERED || status === _helper.TransitionStatuses.EXITING;
    var directionClassName = (status === _helper.TransitionStatuses.ENTERING || status === _helper.TransitionStatuses.EXITING) && startAnimation && (direction === 'right' ? 'carousel-item-left' : 'carousel-item-right');
    var orderClassName = status === _helper.TransitionStatuses.ENTERING && (direction === 'right' ? 'carousel-item-next' : 'carousel-item-prev');
    var itemClasses = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, 'carousel-item', isActive && 'active', directionClassName, orderClassName), cssModule);
    return /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, itemProps, {
      className: itemClasses,
      ref: innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 87,
        columnNumber: 11
      }
    }), children);
  });
};

CCarouselItem.propTypes = process.env.NODE_ENV !== "production" ? _extends({}, _reactTransitionGroup.Transition.propTypes, {
  tag: _helper.tagPropType,
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  "in": _propTypes["default"].bool,
  slide: _propTypes["default"].bool,
  itemProps: _propTypes["default"].object
}) : {};
CCarouselItem.defaultProps = _extends({}, _reactTransitionGroup.Transition.defaultProps, {
  tag: 'div',
  timeout: _helper.TransitionTimeouts.Carousel,
  slide: true
});
var _default = CCarouselItem;
exports["default"] = _default;
module.exports = exports.default;