"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _helper = require("./Shared/helper.js");

var _CCollapseCustom = _interopRequireDefault(require("./CCollapseCustom"));

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CCollapse.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

//component - CoreUI / CCollapse
var omitKeys = ['toggleEvents', 'defaultOpen', 'custom'];

var CCollapse = function CCollapse(props) {
  var custom = props.custom,
      toggle = props.toggle,
      show = props.show;

  var _useState = (0, _react.useState)(props.defaultOpen || false),
      isOpen = _useState[0],
      setIsOpen = _useState[1];

  var fields = (0, _react.useRef)({
    togglers: null,
    removeEventListeners: null
  }).current;

  if (!custom) {
    show = isOpen;
    var userToggle = toggle;

    toggle = function toggle(e) {
      setIsOpen(!isOpen);
      e.preventDefault();
      if (userToggle) userToggle(e);
    };
  } //effect


  (0, _react.useEffect)(function () {
    if (custom) return;
    fields.togglers = (0, _helper.findDOMElements)(props.toggler);

    if (fields.togglers.length) {
      fields.removeEventListeners = (0, _helper.addMultipleEventListeners)(fields.togglers, toggle, props.toggleEvents);
    }

    return function cleanup() {
      if (fields.togglers.length && fields.removeEventListeners) {
        fields.removeEventListeners();
      }
    };
  }); //render

  return /*#__PURE__*/_react["default"].createElement(_CCollapseCustom["default"], _extends({
    show: show
  }, (0, _helper.omit)(props, omitKeys), {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 59,
      columnNumber: 10
    }
  }));
};

CCollapse.propTypes = process.env.NODE_ENV !== "production" ? {
  custom: _propTypes["default"].bool,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  defaultOpen: _propTypes["default"].bool,
  toggler: _propTypes["default"].string,
  toggleEvents: _propTypes["default"].arrayOf(_propTypes["default"].string),
  toggle: _propTypes["default"].func,
  show: _propTypes["default"].bool
} : {};
CCollapse.defaultProps = {
  toggleEvents: _helper.defaultToggleEvents
};
var _default = CCollapse;
exports["default"] = _default;
module.exports = exports.default;