"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CCustomInput.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CCustomInput
var CCustomInput = function CCustomInput(props) {
  var children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      label = props.label,
      inline = props.inline,
      valid = props.valid,
      invalid = props.invalid,
      bsSize = props.bsSize,
      wrapperProps = props.wrapperProps,
      attributes = _objectWithoutPropertiesLoose(props, ["children", "className", "cssModule", "innerRef", "label", "inline", "valid", "invalid", "bsSize", "wrapperProps"]); //render


  var type = attributes.type;
  var customClass = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, "custom-" + type, bsSize ? "custom-" + type + "-" + bsSize : false), cssModule);
  var validationClassNames = (0, _helper.mapToCssModules)((0, _classnames["default"])(invalid && 'is-invalid', valid && 'is-valid'), cssModule);

  if (type === 'select') {
    return /*#__PURE__*/_react["default"].createElement("select", _extends({}, attributes, {
      className: (0, _classnames["default"])(validationClassNames, customClass),
      ref: innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 41,
        columnNumber: 12
      }
    }), children);
  }

  if (type === 'file') {
    return /*#__PURE__*/_react["default"].createElement("div", _extends({
      className: customClass
    }, wrapperProps, {
      ref: innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 46,
        columnNumber: 7
      }
    }), /*#__PURE__*/_react["default"].createElement("input", _extends({}, attributes, {
      className: (0, _classnames["default"])(validationClassNames, (0, _helper.mapToCssModules)('custom-file-input', cssModule)),
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 47,
        columnNumber: 9
      }
    })), /*#__PURE__*/_react["default"].createElement("label", {
      className: (0, _helper.mapToCssModules)('custom-file-label', cssModule),
      htmlFor: attributes.id,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 48,
        columnNumber: 9
      }
    }, label || 'Choose file'));
  }

  if (type !== 'checkbox' && type !== 'radio' && type !== 'switch') {
    return /*#__PURE__*/_react["default"].createElement("input", _extends({}, attributes, {
      className: (0, _classnames["default"])(validationClassNames, customClass),
      ref: innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 54,
        columnNumber: 12
      }
    }));
  }

  var wrapperClasses = (0, _classnames["default"])(customClass, (0, _helper.mapToCssModules)((0, _classnames["default"])('custom-control', {
    'custom-control-inline': inline
  }), cssModule));
  return /*#__PURE__*/_react["default"].createElement("div", _extends({}, wrapperProps, {
    className: wrapperClasses,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 66,
      columnNumber: 5
    }
  }), /*#__PURE__*/_react["default"].createElement("input", _extends({}, attributes, {
    type: type === 'switch' ? 'checkbox' : type,
    className: (0, _classnames["default"])(validationClassNames, (0, _helper.mapToCssModules)('custom-control-input', cssModule)),
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 67,
      columnNumber: 7
    }
  })), /*#__PURE__*/_react["default"].createElement("label", {
    className: (0, _helper.mapToCssModules)('custom-control-label', cssModule),
    htmlFor: attributes.id,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 73,
      columnNumber: 7
    }
  }, label), children);
};

CCustomInput.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].array, _propTypes["default"].func]),
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  id: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]).isRequired,
  type: _propTypes["default"].string.isRequired,
  label: _propTypes["default"].node,
  inline: _propTypes["default"].bool,
  valid: _propTypes["default"].bool,
  invalid: _propTypes["default"].bool,
  bsSize: _propTypes["default"].string,
  wrapperProps: _propTypes["default"].object
} : {};
var _default = CCustomInput;
exports["default"] = _default;
module.exports = exports.default;