"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _Slot = _interopRequireDefault(require("./Shared/Slot"));

var _CSpinner = _interopRequireDefault(require("./CSpinner"));

var _CPagination = _interopRequireDefault(require("./CPagination"));

var _CDataTableModule = _interopRequireDefault(require("./CDataTable.module.css"));

var _iconsReact = require("@coreui/icons-react");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CDataTable.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

//component - CoreUI / CTable
var CDataTable = function CDataTable(props) {
  var children = props.children,
      innerRef = props.innerRef,
      overTableSlot = props.overTableSlot,
      columnHeaderSlot = props.columnHeaderSlot,
      sortingIconSlot = props.sortingIconSlot,
      columnFilterSlot = props.columnFilterSlot,
      detailsSlot = props.detailsSlot,
      noItemViewSlot = props.noItemViewSlot,
      captionSlot = props.captionSlot,
      underTableSlot = props.underTableSlot,
      colNameSlot = props.colNameSlot,
      scopedSlots = props.scopedSlots,
      fields = props.fields,
      pagination = props.pagination,
      activePage = props.activePage,
      itemsPerPage = props.itemsPerPage,
      items = props.items,
      sorter = props.sorter,
      clickableRows = props.clickableRows,
      columnFilter = props.columnFilter,
      tableFilterValue = props.tableFilterValue,
      tableFilter = props.tableFilter,
      addTableClasses = props.addTableClasses,
      size = props.size,
      dark = props.dark,
      striped = props.striped,
      fixed = props.fixed,
      hover = props.hover,
      border = props.border,
      outlined = props.outlined,
      responsive = props.responsive,
      footer = props.footer,
      itemsPerPageSelect = props.itemsPerPageSelect,
      loading = props.loading,
      change = props.change,
      onChange = props.onChange,
      customContent = props.customContent,
      sorterValue = props.sorterValue,
      columnFilterValue = props.columnFilterValue; //Object.assign(style, cssModule)

  var compData = (0, _react.useRef)({
    firstRun: true
  }).current; // vars
  //

  var _useState = (0, _react.useState)(itemsPerPage),
      perPageItems = _useState[0],
      setPerPageItems = _useState[1];

  var _useState2 = (0, _react.useState)({
    column: null,
    asc: true
  }),
      sorterState = _useState2[0],
      setSorterState = _useState2[1];

  var _useState3 = (0, _react.useState)(tableFilterValue),
      tableFilterState = _useState3[0],
      setTableFilterState = _useState3[1];

  var _useState4 = (0, _react.useState)({}),
      columnFilterState = _useState4[0],
      setColumnFilterState = _useState4[1];

  var _useState5 = (0, _react.useState)(activePage || 1),
      page = _useState5[0],
      setPage = _useState5[1];

  var _useState6 = (0, _react.useState)(items || []),
      passedItems = _useState6[0],
      setPassedItems = _useState6[1]; // functions


  var cellClass = function cellClass(item, colName, index) {
    var classes = [];

    if (item._cellClasses && item._cellClasses[colName]) {
      classes.push(item._cellClasses[colName]);
    }

    if (fields && fields[index]._classes) {
      classes.push(fields[index]._classes);
    }

    return classes;
  };

  var pretifyName = function pretifyName(name) {
    return name.replace(/[-_.]/g, ' ').replace(/ +/g, ' ').replace(/([a-z0-9])([A-Z])/g, '$1 $2').split(' ').map(function (word) {
      return word.charAt(0).toUpperCase() + word.slice(1);
    }).join(' ');
  };

  var headerClass = function headerClass(index) {
    //const fields = this.fields ???
    return fields && fields[index]._classes ? fields[index]._classes : '';
  };

  var isSortable = function isSortable(index) {
    return sorter && (!fields || fields[index].sorter !== false);
  };

  var headerStyles = function headerStyles(index) {
    var style = {};

    if (isSortable(index)) {
      style['cursor'] = 'pointer';
    }

    if (fields && fields[index] && fields[index]._style) {
      var r = fields[index]._style.split(':');

      style[r[0]] = r[1].substr(0, r[1].length - 2);
    }

    return style;
  };

  var getIconState = function getIconState(index) {
    var direction = sorterState.asc ? 'asc' : 'desc';
    return rawColumnNames[index] === sorterState.column ? direction : 0;
  };

  var iconClasses = function iconClasses(index) {
    var state = getIconState(index);
    return [_CDataTableModule["default"]['icon-transition position-absolute arrow-position'], !state ? _CDataTableModule["default"]['transparent'] : '', state === 'desc' ? _CDataTableModule["default"]['rotate-icon'] : ''];
  };

  var rowClicked = function rowClicked(item, index) {
    onChange && onChange('row-clicked', item, index);
  };

  var changeSort = function changeSort(column, index) {
    if (isSortable(index)) {
      return;
    } //if column changed or sort was descending change asc to true


    var state = sorterState;
    var columnRepeated = state.column === column;

    if (!sorter || !sorter.resetable) {
      state.column = column;
    } else {
      state.column = columnRepeated && state.asc === false ? null : column;
    }

    state.asc = !(columnRepeated && state.asc);
    onChange && onChange('update:sorter-value', sorterState);
  };

  var paginationChange = function paginationChange(e) {
    onChange && onChange('pagination-change', Number(e.target.value));
    setPerPageItems(Number(e.target.value));
  };

  var columnFilterEvent = function columnFilterEvent(colName, value, type) {
    var isLazy = columnFilter && columnFilter.lazy === true;

    if (isLazy && type === 'input' || !isLazy && type === 'change') {
      return;
    }

    var state = {};
    state[colName] = value;
    setColumnFilterState(_extends({}, columnFilterState, {}, state));
    onChange && onChange('update:column-filter-value', columnFilterState);
  };

  var tableFilterChange = function tableFilterChange(value, type) {
    var isLazy = tableFilter && tableFilter.lazy === true;

    if (isLazy && type === 'input' || !isLazy && type === 'change') {
      return;
    }

    setTableFilterState(value);
    onChange && onChange('update:table-filter-value', tableFilterState);
  }; // computed


  var generatedColumnNames = Object.keys(passedItems[0] || {}).filter(function (el) {
    return el.charAt(0) !== '_';
  });

  var rawColumnNames = function () {
    if (fields) {
      return fields.map(function (el) {
        return el.key || el;
      });
    }

    return generatedColumnNames;
  }();

  var columnFiltered = function () {
    var items = passedItems.slice();

    if (columnFilter && columnFilter.external) {
      return items;
    }

    Object.entries(columnFilterState).forEach(function (_ref) {
      var key = _ref[0],
          value = _ref[1];
      var columnFilter = String(value).toLowerCase();

      if (columnFilter && rawColumnNames.includes(key)) {
        items = items.filter(function (item) {
          return String(item[key]).toLowerCase().includes(columnFilter);
        });
      }
    });
    return items;
  }();

  var filterableCols = function () {
    return rawColumnNames.filter(function (name) {
      return generatedColumnNames.includes(name);
    });
  }();

  var tableFiltered = function () {
    var items = columnFiltered.slice();

    if (!tableFilterState || tableFilter && tableFilter.external) {
      return items;
    }

    var filter = tableFilterState.toLowerCase();

    var hasFilter = function hasFilter(item) {
      return String(item).toLowerCase().includes(filter);
    };

    items = items.filter(function (item) {
      return filterableCols.filter(function (key) {
        return hasFilter(item[key]);
      }).length;
    });
    return items;
  }();

  var sortedItems = function () {
    var col = sorterState.column;

    if (!col || !rawColumnNames.includes(col) || sorter.external) {
      return tableFiltered;
    } //if values in column are to be sorted by numeric value they all have to be type number


    var flip = sorterState.asc ? 1 : -1;
    return tableFiltered.slice().sort(function (a, b) {
      return a[col] > b[col] ? 1 * flip : b[col] > a[col] ? -1 * flip : 0;
    });
  }();

  var tableClasses = function () {
    var _ref2;

    return ['table', addTableClasses, (_ref2 = {}, _ref2["table-" + size] = size, _ref2['table-dark'] = dark, _ref2['table-striped'] = striped, _ref2['b-table-fixed'] = fixed, _ref2['table-hover'] = hover, _ref2['table-bordered'] = border, _ref2['border'] = outlined, _ref2)];
  }();

  var columnNames = function () {
    if (fields) {
      return fields.map(function (f) {
        return f.label !== undefined ? f.label : pretifyName(f.key || f);
      });
    }

    return rawColumnNames.map(function (el) {
      return pretifyName(el);
    });
  }();

  var sortingIconStyles = function () {
    return {
      'position-relative pr-4': sorter
    };
  }();

  var colspan = function () {
    return rawColumnNames.length;
  }();

  var totalPages = function () {
    return Math.ceil(sortedItems.length / perPageItems) || 1;
  }(); //


  var computedPage = pagination ? page : activePage;
  var firstItemIndex = (computedPage - 1) * perPageItems || 0;
  var paginatedItems = sortedItems.slice(firstItemIndex, firstItemIndex + perPageItems);
  var currentItems = computedPage ? paginatedItems : sortedItems;
  var tableFilterData;
  if (tableFilter) tableFilterData = {
    label: tableFilter.label || 'Filter:',
    placeholder: tableFilter.placeholder || 'type string...'
  }; // watch
  //itemsPerPage

  (0, _react.useMemo)(function () {
    if (compData.firstRun) return;
    setPerPageItems(itemsPerPage);
  }, [itemsPerPage]); //sorterValue

  (0, _react.useMemo)(function () {
    var asc = sorterValue.asc === false ? false : true;
    setSorterState(Object.assign({}, {
      asc: asc,
      column: sorterValue.column
    }));
  }, [sorterValue]); //tableFilterValue

  (0, _react.useMemo)(function () {
    if (compData.firstRun) return;
    setTableFilterState(tableFilterValue);
  }, [tableFilterValue]); //columnFilterValue

  (0, _react.useMemo)(function () {
    setColumnFilterState(Object.assign({}, columnFilterValue));
  }, [columnFilterValue]); //items

  (0, _react.useMemo)(function () {
    compData.oldItems = items;
    if (compData.firstRun) return;

    if (items.length !== compData.oldItems.length || JSON.stringify(items) !== JSON.stringify(compData.oldItems)) {
      setPassedItems(items || []);
    }
  }, [items]); //totalPages

  (0, _react.useMemo)(function () {
    onChange && onChange('pages-change', totalPages);
  }, [totalPages]); //get render par

  if (change) change(); // render
  //custom
  //if (custom)
  //  return (<CTableCustom {...attributes} custom={customContent}>{children}</CTableCustom>);

  compData.firstRun = false;
  var paginationProps;
  if (typeof pagination === 'object') paginationProps = _extends({}, pagination);else {
    paginationProps = {};
  }
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 327,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 328,
      columnNumber: 5
    }
  }, itemsPerPageSelect || tableFilter ? /*#__PURE__*/_react["default"].createElement("div", {
    className: "row my-2 mx-0",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 331,
      columnNumber: 9
    }
  }, tableFilter ? /*#__PURE__*/_react["default"].createElement("div", {
    className: "col-sm-6 form-inline p-0",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 334,
      columnNumber: 13
    }
  }, /*#__PURE__*/_react["default"].createElement("label", {
    className: "mr-2",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 335,
      columnNumber: 15
    }
  }, tableFilterData.label), /*#__PURE__*/_react["default"].createElement("input", {
    className: "form-control table-filter",
    type: "text",
    placeholder: tableFilterData.placeholder,
    onInput: function onInput(e) {
      tableFilterChange(e.target.value, 'input');
    },
    onChange: function onChange(e) {
      tableFilterChange(e.target.value, 'change');
    },
    value: tableFilterState,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 336,
      columnNumber: 15
    }
  })) : '', itemsPerPageSelect ? /*#__PURE__*/_react["default"].createElement("div", {
    className: 'col-sm-6 p-0' + (!tableFilter ? 'offset-sm-6' : ''),
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 348,
      columnNumber: 13
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "form-inline justify-content-sm-end",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 351,
      columnNumber: 15
    }
  }, /*#__PURE__*/_react["default"].createElement("label", {
    className: "mr-2",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 352,
      columnNumber: 17
    }
  }, "Items per page:"), /*#__PURE__*/_react["default"].createElement("select", {
    className: "form-control",
    onChange: paginationChange,
    value: 0,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 353,
      columnNumber: 17
    }
  }, /*#__PURE__*/_react["default"].createElement("option", {
    value: "",
    disabled: true,
    hidden: true,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 358,
      columnNumber: 19
    }
  }, perPageItems), [5, 10, 20, 50].map(function (number, key) {
    return /*#__PURE__*/_react["default"].createElement("option", {
      val: number,
      key: key,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 363,
        columnNumber: 23
      }
    }, number);
  })))) : '') : ''), /*#__PURE__*/_react["default"].createElement(_Slot["default"], {
    content: overTableSlot,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 379,
      columnNumber: 5
    }
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "position-relative " + (responsive ? 'table-responsive' : ''),
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 381,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react["default"].createElement("table", {
    className: (0, _classnames["default"])(tableClasses),
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 382,
      columnNumber: 7
    }
  }, /*#__PURE__*/_react["default"].createElement("thead", {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 383,
      columnNumber: 9
    }
  }, /*#__PURE__*/_react["default"].createElement("tr", {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 384,
      columnNumber: 11
    }
  }, columnNames.map(function (name, index) {
    return /*#__PURE__*/_react["default"].createElement("th", {
      onClick: function onClick() {
        changeSort(rawColumnNames[index], index);
      },
      className: (0, _classnames["default"])([headerClass(index), sortingIconStyles]),
      style: headerStyles(index),
      key: index,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 388,
        columnNumber: 19
      }
    }, /*#__PURE__*/_react["default"].createElement(_Slot["default"], {
      content: columnHeaderSlot["" + rawColumnNames[index]],
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 394,
        columnNumber: 21
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "d-inline",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 395,
        columnNumber: 23
      }
    }, name)), isSortable(index) ? /*#__PURE__*/_react["default"].createElement(_Slot["default"], {
      content: sortingIconSlot,
      state: getIconState(index),
      classes: iconClasses(index),
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 399,
        columnNumber: 25
      }
    }, /*#__PURE__*/_react["default"].createElement(_iconsReact.CIcon, {
      className: (0, _classnames["default"])(iconClasses(index)),
      width: "18",
      content: "$options.icons.cilArrowTop",
      name: "cil-arrow-top",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 404,
        columnNumber: 27
      }
    })) : '');
  })), columnFilter ? /*#__PURE__*/_react["default"].createElement("tr", {
    className: "table-sm",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 419,
      columnNumber: 15
    }
  }, rawColumnNames.map(function (colName, index) {
    return /*#__PURE__*/_react["default"].createElement("th", {
      className: (0, _classnames["default"])(headerClass(index)),
      key: index,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 423,
        columnNumber: 23
      }
    }, /*#__PURE__*/_react["default"].createElement(_Slot["default"], {
      content: columnFilterSlot["" + rawColumnNames[index]],
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 424,
        columnNumber: 25
      }
    }, !fields || fields[index].filter !== false ? /*#__PURE__*/_react["default"].createElement("input", {
      className: "w-100 table-filter",
      onInput: function onInput(e) {
        columnFilterEvent(colName, e.target.value, 'input');
      },
      onChange: function onChange(e) {
        columnFilterEvent(colName, e.target.value, 'change');
      },
      value: columnFilterState[colName],
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 427,
        columnNumber: 31
      }
    }) : ''));
  })) : ''), /*#__PURE__*/_react["default"].createElement("tbody", {
    style: clickableRows ? {
      cursor: 'pointer'
    } : null,
    className: "position-relative",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 442,
      columnNumber: 9
    }
  }, currentItems.map(function (item, itemIndex) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
      key: itemIndex,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 448,
        columnNumber: 15
      }
    }, /*#__PURE__*/_react["default"].createElement("tr", {
      className: (0, _classnames["default"])(item._classes),
      tabIndex: clickableRows ? 0 : null,
      onClick: function onClick() {
        rowClicked(item, itemIndex + firstItemIndex);
      },
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 449,
        columnNumber: 15
      }
    }, rawColumnNames.map(function (colName, index) {
      if (scopedSlots[colName]) return /*#__PURE__*/_react["default"].createElement(_Slot["default"], {
        content: scopedSlots[colName](item, itemIndex + firstItemIndex),
        key: index,
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 458,
          columnNumber: 25
        }
      });else return /*#__PURE__*/_react["default"].createElement("td", {
        className: (0, _classnames["default"])(cellClass(item, colName, index)),
        key: index,
        __self: _this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 465,
          columnNumber: 25
        }
      }, String(item[colName]));
    })), scopedSlots.details ? /*#__PURE__*/_react["default"].createElement("tr", {
      className: "p-0",
      style: {
        border: 'none !important'
      },
      key: 'details' + itemIndex,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 477,
        columnNumber: 19
      }
    }, /*#__PURE__*/_react["default"].createElement("td", {
      colSpan: colspan,
      className: "p-0",
      style: {
        border: 'none !important'
      },
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 482,
        columnNumber: 21
      }
    }, /*#__PURE__*/_react["default"].createElement(_Slot["default"], {
      content: scopedSlots.details(item, itemIndex + firstItemIndex),
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 487,
        columnNumber: 23
      }
    }))) : '');
  }), !currentItems.length ? /*#__PURE__*/_react["default"].createElement("tr", {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 498,
      columnNumber: 15
    }
  }, /*#__PURE__*/_react["default"].createElement("td", {
    colSpan: colspan,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 499,
      columnNumber: 17
    }
  }, /*#__PURE__*/_react["default"].createElement(_Slot["default"], {
    content: noItemViewSlot,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 500,
      columnNumber: 19
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "text-center my-5",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 501,
      columnNumber: 21
    }
  }, /*#__PURE__*/_react["default"].createElement("h2", {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 502,
      columnNumber: 23
    }
  }, passedItems.length ? 'No filtering results ' : 'No items', /*#__PURE__*/_react["default"].createElement(_iconsReact.CIcon, {
    width: "30",
    name: "cilBan",
    content: "$options.icons.cilBan",
    className: "text-danger mb-2",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 504,
      columnNumber: 25
    }
  })))))) : null), footer && currentItems.length > 0 ? /*#__PURE__*/_react["default"].createElement("tfoot", {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 519,
      columnNumber: 13
    }
  }, /*#__PURE__*/_react["default"].createElement("tr", {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 520,
      columnNumber: 15
    }
  }, columnNames.map(function (name, index) {
    return /*#__PURE__*/_react["default"].createElement("th", {
      onClick: changeSort(rawColumnNames[index], index),
      className: (0, _classnames["default"])([headerClass(index), sortingIconStyles]),
      style: headerStyles(index),
      key: index,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 524,
        columnNumber: 23
      }
    }, /*#__PURE__*/_react["default"].createElement(_Slot["default"], {
      content: columnHeaderSlot["" + rawColumnNames[index]],
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 530,
        columnNumber: 25
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "d-inline",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 531,
        columnNumber: 27
      }
    }, name)), isSortable(index) ? /*#__PURE__*/_react["default"].createElement(_Slot["default"], {
      content: sortingIconSlot,
      state: getIconState(index),
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 535,
        columnNumber: 29
      }
    }, /*#__PURE__*/_react["default"].createElement(_iconsReact.CIcon, {
      width: "18",
      name: "cil-arrow-top",
      content: "$options.icons.cilArrowTop",
      className: (0, _classnames["default"])(iconClasses(index)),
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 539,
        columnNumber: 31
      }
    })) : null);
  }))) : null, /*#__PURE__*/_react["default"].createElement(_Slot["default"], {
    content: captionSlot,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 554,
      columnNumber: 9
    }
  })), loading ? /*#__PURE__*/_react["default"].createElement(_Slot["default"], {
    content: children,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 559,
      columnNumber: 11
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      position: 'absolute',
      left: '0',
      top: '0',
      bottom: '0',
      right: '0',
      backgroundColor: 'rgb(255,255,255,0.4)'
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 560,
      columnNumber: 13
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      position: 'absolute',
      bottom: '50%',
      left: '50%',
      transform: 'translateX(-50%)'
    },
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 568,
      columnNumber: 15
    }
  }, /*#__PURE__*/_react["default"].createElement(_CSpinner["default"], {
    color: "success",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 574,
      columnNumber: 17
    }
  })))) : null), /*#__PURE__*/_react["default"].createElement(_Slot["default"], {
    content: underTableSlot,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 582,
      columnNumber: 5
    }
  }), //:activePage.sync="page"
  //v-bind={typeof pagination === 'object' ? {...pagination} : null}
  pagination ? /*#__PURE__*/_react["default"].createElement(_CPagination["default"], _extends({
    style: {
      display: totalPages > 0 ? 'inline' : 'none'
    },
    pages: totalPages
  }, paginationProps, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 588,
      columnNumber: 9
    }
  })) : null);
};

CDataTable.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //custom: PropTypes.bool,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  overTableSlot: _propTypes["default"].node,
  colNameSlot: _propTypes["default"].node,
  //?
  columnHeaderSlot: _propTypes["default"].array,
  sortingIconSlot: _propTypes["default"].node,
  columnFilterSlot: _propTypes["default"].node,
  detailsSlot: _propTypes["default"].node,
  //?
  noItemViewSlot: _propTypes["default"].node,
  captionSlot: _propTypes["default"].node,
  underTableSlot: _propTypes["default"].node,
  scopedSlots: _propTypes["default"].object,
  fields: _propTypes["default"].array,
  pagination: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].object]),
  activePage: _propTypes["default"].number,
  itemsPerPage: _propTypes["default"].number,
  items: _propTypes["default"].array,
  sorter: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].object]),
  clickableRows: _propTypes["default"].bool,
  columnFilter: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].object]),
  tableFilterValue: _propTypes["default"].string,
  tableFilter: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].object]),
  addTableClasses: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].array, _propTypes["default"].object]),
  size: _propTypes["default"].string,
  dark: _propTypes["default"].bool,
  striped: _propTypes["default"].bool,
  fixed: _propTypes["default"].bool,
  hover: _propTypes["default"].bool,
  border: _propTypes["default"].bool,
  outlined: _propTypes["default"].bool,
  responsive: _propTypes["default"].bool,
  footer: _propTypes["default"].bool,
  itemsPerPageSelect: _propTypes["default"].bool,
  loading: _propTypes["default"].bool,
  change: _propTypes["default"].func,
  //+
  onChange: _propTypes["default"].func,
  sorterValue: _propTypes["default"].object,
  columnFilterValue: _propTypes["default"].object
} : {};
CDataTable.defaultProps = {
  itemsPerPage: 10,
  responsive: true,
  columnHeaderSlot: [],
  columnFilterSlot: [],
  sorterValue: {}
};
CDataTable.Context = _react["default"].createContext({});
var _default = CDataTable;
exports["default"] = _default;
module.exports = exports.default;