"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _CEmbedObject = _interopRequireDefault(require("./CEmbedObject"));

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CEmbed.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CEmbed
var CEmbed = function CEmbed(props) {
  var Tag = props.tag,
      className = props.className,
      cssModule = props.cssModule,
      custom = props.custom,
      innerRef = props.innerRef,
      ratio = props.ratio,
      type = props.type,
      src = props.src,
      objectClassName = props.objectClassName,
      objectProps = props.objectProps,
      attributes = _objectWithoutPropertiesLoose(props, ["tag", "className", "cssModule", "custom", "innerRef", "ratio", "type", "src", "objectClassName", "objectProps"]); //render


  var classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, ratio ? "embed-responsive-" + ratio : null, 'embed-responsive'), cssModule);
  var objectClasses = (0, _helper.mapToCssModules)((0, _classnames["default"])(objectClassName), cssModule);

  if (!custom) {
    return /*#__PURE__*/_react["default"].createElement(Tag, _extends({
      className: classes
    }, attributes, {
      ref: innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 40,
        columnNumber: 7
      }
    }), /*#__PURE__*/_react["default"].createElement(_CEmbedObject["default"], _extends({}, objectProps, {
      className: objectClasses,
      type: type,
      src: src,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 41,
        columnNumber: 9
      }
    })));
  }

  return /*#__PURE__*/_react["default"].createElement(Tag, _extends({
    className: classes
  }, attributes, {
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 47,
      columnNumber: 5
    }
  }));
};

CEmbed.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  custom: _propTypes["default"].bool,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  ratio: _propTypes["default"].string,
  objectClassName: _propTypes["default"].string,
  objectProps: _propTypes["default"].object,
  ///
  type: _propTypes["default"].string,
  src: _propTypes["default"].string
} : {};
CEmbed.defaultProps = {
  tag: 'span',
  ratio: '16by9',
  type: 'iframe'
};
var _default = CEmbed;
exports["default"] = _default;
module.exports = exports.default;