"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CInput.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CInput
var CInput = function CInput(props) {
  var tag = props.tag,
      className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      type = props.type,
      bsSize = props.bsSize,
      valid = props.valid,
      invalid = props.invalid,
      addon = props.addon,
      staticInput = props["static"],
      plaintext = props.plaintext,
      attributes = _objectWithoutPropertiesLoose(props, ["tag", "className", "cssModule", "innerRef", "type", "bsSize", "valid", "invalid", "addon", "static", "plaintext"]);
  /*
  let fields = useRef({}).current;
    const getRef = (ref)=>{
    fields.ref = ref;
    innerRef && innerRef(ref);
  }
    const focus = ()=>{
    if (fields.ref) {
      fields.ref.focus();
    }
  }
  */
  // render


  var checkInput = ['radio', 'checkbox'].indexOf(type) > -1;
  var isNotaNumber = new RegExp('\\D', 'g');
  var fileInput = type === 'file';
  var textareaInput = type === 'textarea';
  var selectInput = type === 'select';
  var Tag = tag || (selectInput || textareaInput ? type : 'input');
  var formControlClass = 'form-control';

  if (plaintext || staticInput) {
    formControlClass = formControlClass + "-plaintext";
    Tag = tag || 'input';
  } else if (fileInput) {
    formControlClass = formControlClass + "-file";
  } else if (checkInput) {
    if (addon) {
      formControlClass = null;
    } else {
      formControlClass = 'form-check-input';
    }
  }

  if (attributes.size && isNotaNumber.test(attributes.size)) {
    (0, _helper.warnOnce)('Please use the prop "bsSize" instead of the "size" to bootstrap\'s input sizing.');
    bsSize = attributes.size;
    delete attributes.size;
  }

  var classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, invalid && 'is-invalid', valid && 'is-valid', bsSize ? "form-control-" + bsSize : false, formControlClass), cssModule);

  if (Tag === 'input' || tag && typeof tag === 'function') {
    attributes.type = type;
  }

  if (attributes.children && !(plaintext || staticInput || type === 'select' || typeof Tag !== 'string' || Tag === 'select')) {
    (0, _helper.warnOnce)("Input with a type of \"" + type + "\" cannot have children. Please use \"value\"/\"defaultValue\" instead.");
    delete attributes.children;
  }

  return /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, attributes, {
    className: classes,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 105,
      columnNumber: 10
    }
  }));
};

CInput.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  type: _propTypes["default"].string,
  size: _propTypes["default"].string,
  bsSize: _propTypes["default"].string,
  valid: _propTypes["default"].bool,
  invalid: _propTypes["default"].bool,
  plaintext: _propTypes["default"].bool,
  addon: _propTypes["default"].bool,
  "static": _propTypes["default"].bool
} : {};
CInput.defaultProps = {
  type: 'text'
};
var _default = CInput;
exports["default"] = _default;
module.exports = exports.default;