"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _CLink = _interopRequireDefault(require("./CLink"));

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CListGroupItem.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CListGroupItem
var CListGroupItem = function CListGroupItem(props) {
  var Tag = props.tag,
      className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      active = props.active,
      disabled = props.disabled,
      action = props.action,
      color = props.color,
      accent = props.accent,
      attributes = _objectWithoutPropertiesLoose(props, ["tag", "className", "cssModule", "innerRef", "active", "disabled", "action", "color", "accent"]);

  if (disabled) {
    attributes.onClick = function (e) {
      e.preventDefault();
    };
  } //render


  var classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, active ? 'active' : false, disabled ? 'disabled' : false, action || attributes.href || attributes.to || Tag == 'button' ? 'list-group-item-action' : false, color ? "list-group-item-" + color : false, accent ? "list-group-item-accent-" + accent : false, 'list-group-item'), cssModule);

  if (props.href || props.to) {
    Tag = _CLink["default"];
    return /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, attributes, {
      className: classes,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 46,
        columnNumber: 7
      }
    }));
  } else {
    return /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, attributes, {
      className: classes,
      ref: innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 51,
        columnNumber: 7
      }
    }));
  }
};

CListGroupItem.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  className: _propTypes["default"].any,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  active: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  color: _propTypes["default"].string,
  accent: _propTypes["default"].string,
  action: _propTypes["default"].bool
} : {};
CListGroupItem.defaultProps = {
  tag: 'li'
};
var _default = CListGroupItem;
exports["default"] = _default;
module.exports = exports.default;