"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CModalHeader.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CModalHeader
var CModalHeader = function CModalHeader(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      toggle = props.toggle,
      WrapTag = props.wrapTag,
      closeAriaLabel = props.closeAriaLabel,
      charCode = props.charCode,
      close = props.close,
      mainClassName = props.mainClassName,
      mainProps = props.mainProps,
      attributes = _objectWithoutPropertiesLoose(props, ["tag", "children", "className", "cssModule", "innerRef", "toggle", "wrapTag", "closeAriaLabel", "charCode", "close", "mainClassName", "mainProps"]); //render


  var closeButton;
  var classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, 'modal-header'), cssModule);
  var mainClasses = (0, _helper.mapToCssModules)((0, _classnames["default"])(mainClassName, 'modal-title'), cssModule);

  if (!close && toggle) {
    var closeIcon = typeof charCode === 'number' ? String.fromCharCode(charCode) : charCode;
    closeButton = /*#__PURE__*/_react["default"].createElement("button", {
      type: "button",
      onClick: toggle,
      className: (0, _helper.mapToCssModules)('close', cssModule),
      "aria-label": closeAriaLabel,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 44,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react["default"].createElement("span", {
      "aria-hidden": "true",
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 45,
        columnNumber: 9
      }
    }, closeIcon));
  }

  return /*#__PURE__*/_react["default"].createElement(WrapTag, _extends({}, attributes, {
    className: classes,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 51,
      columnNumber: 5
    }
  }), /*#__PURE__*/_react["default"].createElement(Tag, _extends({
    className: mainClasses
  }, mainProps, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 52,
      columnNumber: 7
    }
  }), children), close || closeButton);
};

CModalHeader.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  wrapTag: _helper.tagPropType,
  toggle: _propTypes["default"].func,
  closeAriaLabel: _propTypes["default"].string,
  charCode: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  close: _propTypes["default"].object,
  mainClassName: _propTypes["default"].string,
  mainProps: _propTypes["default"].object
} : {};
CModalHeader.defaultProps = {
  tag: 'h5',
  wrapTag: 'div',
  closeAriaLabel: 'Close',
  charCode: 215
};
var _default = CModalHeader;
exports["default"] = _default;
module.exports = exports.default;