"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CNav.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CNav
var CNav = function CNav(props) {
  var Tag = props.tag,
      className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      variant = props.variant,
      vertical = props.vertical,
      horizontal = props.horizontal,
      justified = props.justified,
      fill = props.fill,
      inCard = props.inCard,
      attributes = _objectWithoutPropertiesLoose(props, ["tag", "className", "cssModule", "innerRef", "variant", "vertical", "horizontal", "justified", "fill", "inCard"]);

  var getVerticalClass = function getVerticalClass(vertical) {
    if (vertical === false) {
      return false;
    } else if (vertical === true || vertical === 'xs') {
      return 'flex-column';
    }

    return "flex-" + vertical + "-column";
  }; //render


  var classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, 'nav', horizontal ? "justify-content-" + horizontal : false, variant == 'tabs' ? 'nav-tabs' : variant == 'pills' ? 'nav-pills' : null, getVerticalClass(vertical), {
    'card-header-tabs': inCard && variant == 'tabs',
    'card-header-pills': inCard && variant == 'pills',
    'nav-justified': justified,
    'nav-fill': fill
  }), cssModule);
  return /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, attributes, {
    className: classes,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 51,
      columnNumber: 5
    }
  }));
};

CNav.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  variant: _propTypes["default"].oneOf(['', 'tabs', 'pills']),
  vertical: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].string]),
  horizontal: _propTypes["default"].string,
  justified: _propTypes["default"].bool,
  fill: _propTypes["default"].bool,
  inCard: _propTypes["default"].bool
} : {};
CNav.defaultProps = {
  tag: 'ul',
  vertical: false
};
var _default = CNav;
exports["default"] = _default;
module.exports = exports.default;