"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _CPaginationLink = _interopRequireDefault(require("./CPaginationLink"));

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CPaginationItem.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CPaginationItem
var CPaginationItem = function CPaginationItem(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      custom = props.custom,
      innerRef = props.innerRef,
      active = props.active,
      disabled = props.disabled,
      linkClassName = props.linkClassName,
      linkProps = props.linkProps,
      attributes = _objectWithoutPropertiesLoose(props, ["tag", "children", "className", "cssModule", "custom", "innerRef", "active", "disabled", "linkClassName", "linkProps"]); //render


  var classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, 'page-item', {
    'active': active,
    'disabled': disabled
  }), cssModule);
  var linkClasses = (0, _helper.mapToCssModules)((0, _classnames["default"])(linkClassName), cssModule);

  if (!custom) {
    return /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, attributes, {
      className: classes,
      ref: innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 43,
        columnNumber: 7
      }
    }), /*#__PURE__*/_react["default"].createElement(_CPaginationLink["default"], _extends({
      className: linkClasses
    }, linkProps, {
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 44,
        columnNumber: 9
      }
    }), children));
  }

  return /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, attributes, {
    className: classes,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 52,
      columnNumber: 5
    }
  }), children);
};

CPaginationItem.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  custom: _propTypes["default"].bool,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  active: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  linkClassName: _propTypes["default"].string,
  linkProps: _propTypes["default"].object
} : {};
CPaginationItem.defaultProps = {
  tag: 'li',
  active: false
};
var _default = CPaginationItem;
exports["default"] = _default;
module.exports = exports.default;