"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _lodash = _interopRequireDefault(require("lodash.tonumber"));

var _helper = require("./Shared/helper.js");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CProgress.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CProgress
var CProgress = function CProgress(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      barClassName = props.barClassName,
      barProps = props.barProps,
      height = props.height,
      value = props.value,
      max = props.max,
      animated = props.animated,
      striped = props.striped,
      color = props.color,
      bar = props.bar,
      multi = props.multi,
      showPercentage = props.showPercentage,
      showValue = props.showValue,
      precision = props.precision,
      size = props.size,
      attributes = _objectWithoutPropertiesLoose(props, ["tag", "children", "className", "cssModule", "innerRef", "barClassName", "barProps", "height", "value", "max", "animated", "striped", "color", "bar", "multi", "showPercentage", "showValue", "precision", "size"]);

  var valueNumber = (0, _lodash["default"])(value);
  var percent = valueNumber / (0, _lodash["default"])(max) * 100; // render

  var progressClasses = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, size ? 'progress-' + size : null, 'progress'), cssModule);
  var progressBarClasses = (0, _helper.mapToCssModules)((0, _classnames["default"])('progress-bar', bar ? className || barClassName : barClassName, animated ? 'progress-bar-animated' : null, color ? "bg-" + color : null, striped || animated ? 'progress-bar-striped' : null), cssModule);
  if (precision) percent = percent.toPrecision(precision);
  if (precision) valueNumber = valueNumber.toPrecision(precision);
  var ProgressBar = multi ? children : /*#__PURE__*/_react["default"].createElement("div", _extends({
    className: progressBarClasses,
    style: {
      width: percent + "%"
    },
    role: "progressbar",
    "aria-valuenow": value,
    "aria-valuemin": "0",
    "aria-valuemax": max
  }, barProps, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 60,
      columnNumber: 5
    }
  }), showPercentage ? percent + '%' : showValue ? value : children);

  if (bar) {
    return ProgressBar;
  }

  var style;
  if (height) style = {
    height: height
  };else style = {};
  return /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, attributes, {
    style: style,
    className: progressClasses,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 84,
      columnNumber: 5
    }
  }), ProgressBar);
};

CProgress.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  barClassName: _propTypes["default"].string,
  barProps: _propTypes["default"].object,
  height: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  bar: _propTypes["default"].bool,
  multi: _propTypes["default"].bool,
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  max: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  animated: _propTypes["default"].bool,
  striped: _propTypes["default"].bool,
  color: _propTypes["default"].string,
  precision: _propTypes["default"].number,
  showPercentage: _propTypes["default"].bool,
  showValue: _propTypes["default"].bool,
  size: _propTypes["default"].string
} : {};
CProgress.defaultProps = {
  tag: 'div',
  value: 0,
  max: 100
};
var _default = CProgress;
exports["default"] = _default;
module.exports = exports.default;