"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _CLink = _interopRequireDefault(require("./CLink"));

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CSidebarBrand.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CSidebarBrand
var CSidebarBrand = function CSidebarBrand(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      custom = props.custom,
      innerRef = props.innerRef,
      img = props.img,
      imgFull = props.imgFull,
      imgMinimized = props.imgMinimized,
      wrappedInLink = props.wrappedInLink,
      linkClassName = props.linkClassName,
      linkProps = props.linkProps,
      attributes = _objectWithoutPropertiesLoose(props, ["tag", "children", "className", "custom", "innerRef", "img", "imgFull", "imgMinimized", "wrappedInLink", "linkClassName", "linkProps"]);

  var imgSrc = function imgSrc(brand) {
    return brand.src ? brand.src : '';
  };

  var imgWidth = function imgWidth(brand) {
    return brand.width ? brand.width : 'auto';
  };

  var imgHeight = function imgHeight(brand) {
    return brand.height ? brand.height : 'auto';
  };

  var imgAlt = function imgAlt(brand) {
    return brand.alt ? brand.alt : '';
  };

  var navbarBrandImg = function navbarBrandImg(props, classBrand, key) {
    /*
    const {
      src,
      width,
      alt,
      height,
      ...attributes
    } = props;
    */
    return /*#__PURE__*/_react["default"].createElement("img", _extends({
      src: imgSrc(props),
      width: imgWidth(props),
      height: imgHeight(props),
      alt: imgAlt(props),
      className: classBrand
    }, props, {
      key: key.toString(),
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 49,
        columnNumber: 7
      }
    }));
  }; // render


  var classes = (0, _classnames["default"])(className, 'c-sidebar-brand');

  if (custom) {
    return /*#__PURE__*/_react["default"].createElement(Tag, _extends({
      className: classes
    }, attributes, {
      ref: innerRef,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 70,
        columnNumber: 7
      }
    }), children);
  }

  var classesLink = (0, _classnames["default"])(linkClassName, 'c-sidebar-brand');
  var imgChildren = [];

  if (imgFull) {
    imgChildren.push(navbarBrandImg(imgFull || img, 'c-sidebar-brand-full', 1));
  }

  if (imgMinimized) {
    imgChildren.push(navbarBrandImg(imgMinimized || img, 'c-sidebar-brand-minimized', imgChildren.length + 1));
  }

  return /*#__PURE__*/_react["default"].createElement(Tag, _extends({}, attributes, {
    className: classes,
    ref: innerRef,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 90,
      columnNumber: 5
    }
  }), wrappedInLink ? /*#__PURE__*/_react["default"].createElement(_CLink["default"], _extends({
    className: classesLink
  }, linkProps, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 93,
      columnNumber: 11
    }
  }), imgChildren) : imgChildren);
};

CSidebarBrand.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].string]),
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  custom: _propTypes["default"].bool,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  img: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].string]),
  imgFull: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].string]),
  imgMinimized: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].string]),
  linkClassName: _propTypes["default"].string,
  linkProps: _propTypes["default"].object,
  wrappedInLink: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].string])
} : {};
CSidebarBrand.defaultProps = {
  tag: 'div'
};
var _default = CSidebarBrand;
exports["default"] = _default;
module.exports = exports.default;