"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _CLink = _interopRequireDefault(require("./CLink"));

var _CBadge = _interopRequireDefault(require("./CBadge"));

var _iconsReact = require("@coreui/icons-react");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CSidebarNavLink.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CSidebarNavLink
var CSidebarNavLink = function CSidebarNavLink(props) {
  var children = props.children,
      className = props.className,
      custom = props.custom,
      label = props.label,
      icon = props.icon,
      fontIcon = props.fontIcon,
      badgeClassName = props.badgeClassName,
      badgeProps = props.badgeProps,
      attributes = _objectWithoutPropertiesLoose(props, ["children", "className", "custom", "label", "icon", "fontIcon", "badgeClassName", "badgeProps"]); // render


  var classes = (0, _classnames["default"])(className, label ? 'c-sidebar-nav-label' : 'c-sidebar-nav-link');
  var iconProps;
  if (typeof icon === 'object') iconProps = icon;else iconProps = {
    name: icon
  };

  if (!custom) {
    var iconClasses = (0, _classnames["default"])('c-sidebar-nav-icon', fontIcon ? fontIcon : null);
    var badgeClasses = (0, _classnames["default"])(badgeClassName);
    return /*#__PURE__*/_react["default"].createElement(_CLink["default"], _extends({}, attributes, {
      className: classes,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 47,
        columnNumber: 7
      }
    }), icon ? /*#__PURE__*/_react["default"].createElement(_iconsReact.CIcon, _extends({
      className: "c-sidebar-nav-icon"
    }, iconProps, {
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 48,
        columnNumber: 15
      }
    })) : '', fontIcon ? /*#__PURE__*/_react["default"].createElement("i", {
      className: iconClasses,
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 49,
        columnNumber: 19
      }
    }) : '', children, badgeProps ? /*#__PURE__*/_react["default"].createElement(_CBadge["default"], _extends({
      className: badgeClasses
    }, badgeProps, {
      __self: _this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 51,
        columnNumber: 21
      }
    }), badgeProps.text) : '');
  }

  return /*#__PURE__*/_react["default"].createElement(_CLink["default"], _extends({}, attributes, {
    className: classes,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 57,
      columnNumber: 5
    }
  }));
};

CSidebarNavLink.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  custom: _propTypes["default"].bool,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].string, _propTypes["default"].object]),
  icon: _propTypes["default"].oneOfType(['string', 'object']),
  label: _propTypes["default"].bool,
  fontIcon: _propTypes["default"].string,
  badgeProps: _propTypes["default"].object,
  badgeClassName: _propTypes["default"].object
} : {};
CSidebarNavLink.defaultProps = {};
var _default = CSidebarNavLink;
exports["default"] = _default;
module.exports = exports.default;