"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _CCard = _interopRequireDefault(require("./CCard"));

var _CCardBody = _interopRequireDefault(require("./CCardBody"));

var _CCardFooter = _interopRequireDefault(require("./CCardFooter"));

var _iconsReact = require("@coreui/icons-react");

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CWidgetIcon.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CWidgetIcon
var CWidgetIcon = function CWidgetIcon(props) {
  var className = props.className,
      cssModule = props.cssModule,
      header = props.header,
      mainText = props.mainText,
      icon = props.icon,
      color = props.color,
      footer = props.footer,
      link = props.link,
      variant = props.variant,
      attributes = _objectWithoutPropertiesLoose(props, ["className", "cssModule", "header", "mainText", "icon", "color", "footer", "link", "variant"]);

  var padding = variant === '0' ? {
    card: 'p-3',
    icon: 'p-3'
  } : variant === '1' ? {
    card: 'p-0',
    icon: 'p-4',
    lead: 'pt-3'
  } : {
    card: 'p-0',
    icon: 'p-4 px-5',
    lead: 'pt-3'
  };
  var card = {
    style: 'd-flex',
    color: color,
    icon: icon,
    classes: ''
  };
  card.classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, card.style, padding.card, 'align-items-center'), cssModule);
  var lead = {
    style: 'text-value',
    color: color,
    classes: ''
  };
  lead.classes = (0, _classnames["default"])(lead.style, 'text-' + card.color);

  var blockIcon = function blockIcon(icon) {
    var classes = (0, _classnames["default"])('bg-' + card.color, 'text-white', padding.icon, 'mr-3 float-left');
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: classes,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 42,
        columnNumber: 12
      }
    }, /*#__PURE__*/_react["default"].createElement(_iconsReact.CIcon, {
      name: icon,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 42,
        columnNumber: 37
      }
    }));
  };

  var cardFooter = function cardFooter() {
    if (footer) {
      return /*#__PURE__*/_react["default"].createElement(_CCardFooter["default"], {
        className: "px-3 py-2",
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 48,
          columnNumber: 9
        }
      }, /*#__PURE__*/_react["default"].createElement("a", {
        className: "align-items-center btn-block d-flex justify-content-between text-muted",
        href: link,
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 49,
          columnNumber: 11
        }
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "small font-weight-bold",
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 50,
          columnNumber: 13
        }
      }, "View More"), /*#__PURE__*/_react["default"].createElement(_iconsReact.CIcon, {
        className: "float-right",
        name: "cil-chevron-right",
        size: "lg",
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 53,
          columnNumber: 13
        }
      })));
    }
  };

  return /*#__PURE__*/_react["default"].createElement(_CCard["default"], _extends({}, attributes, {
    custom: true,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 61,
      columnNumber: 5
    }
  }), /*#__PURE__*/_react["default"].createElement(_CCardBody["default"], _extends({
    className: card.classes
  }, attributes, {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 62,
      columnNumber: 7
    }
  }), /*#__PURE__*/_react["default"].createElement("div", {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 63,
      columnNumber: 9
    }
  }, blockIcon(card.icon)), /*#__PURE__*/_react["default"].createElement("div", {
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 66,
      columnNumber: 9
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: lead.classes,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 67,
      columnNumber: 11
    }
  }, header), /*#__PURE__*/_react["default"].createElement("div", {
    className: "text-muted text-uppercase font-weight-bold small",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 68,
      columnNumber: 11
    }
  }, mainText))), cardFooter());
};

CWidgetIcon.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  header: _propTypes["default"].string,
  mainText: _propTypes["default"].string,
  icon: _propTypes["default"].string,
  color: _propTypes["default"].string,
  variant: _propTypes["default"].string,
  footer: _propTypes["default"].bool,
  link: _propTypes["default"].string
} : {};
CWidgetIcon.defaultProps = {
  header: '$1,999.50',
  mainText: 'Widget title',
  icon: 'cil-settings',
  color: 'primary',
  variant: '0',
  link: '#'
};
var _default = CWidgetIcon;
exports["default"] = _default;
module.exports = exports.default;