"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _helper = require("./Shared/helper.js");

var _CCard = _interopRequireDefault(require("./CCard"));

var _CCardBody = _interopRequireDefault(require("./CCardBody"));

var _this = void 0,
    _jsxFileName = "D:\\_Repos\\_CoreUIv3\\React\\coreui-react-internal\\src\\CWidgetSimple.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//import CCardHeader from './CCardHeader';
//import CCardFooter from './CCardFooter';
//component - CoreUI / CWidgetSimple
var CWidgetSimple = function CWidgetSimple(props) {
  var children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      header = props.header,
      mainText = props.mainText,
      color = props.color,
      variant = props.variant,
      attributes = _objectWithoutPropertiesLoose(props, ["children", "className", "cssModule", "header", "mainText", "color", "variant"]);

  var card = {
    style: '',
    bgColor: ''
  };

  if (variant === 'inverse') {
    card.style = 'text-white';
    card.bgColor = 'bg-' + color;
  }

  var classes = (0, _helper.mapToCssModules)((0, _classnames["default"])(className, card.style, card.bgColor), cssModule);
  return /*#__PURE__*/_react["default"].createElement(_CCard["default"], _extends({}, attributes, {
    custom: true,
    className: classes,
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 39,
      columnNumber: 5
    }
  }), /*#__PURE__*/_react["default"].createElement(_CCardBody["default"], {
    className: "text-center",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 40,
      columnNumber: 7
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "text-muted small text-uppercase font-weight-bold",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 55,
      columnNumber: 9
    }
  }, header), /*#__PURE__*/_react["default"].createElement("div", {
    className: "text-value-xl py-3",
    __self: _this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 56,
      columnNumber: 9
    }
  }, mainText), children));
};

CWidgetSimple.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  cssModule: _propTypes["default"].object,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  header: _propTypes["default"].string,
  mainText: _propTypes["default"].string,
  color: _propTypes["default"].string,
  variant: _propTypes["default"].string
} : {};
CWidgetSimple.defaultProps = {
  header: 'title',
  mainText: 'text',
  color: '',
  variant: ''
};
var _default = CWidgetSimple;
exports["default"] = _default;
module.exports = exports.default;